<template>
    <div class="default-main">
        <!-- <TableHeader ref='TableHeaderRef'>
        <template #select>
            <el-form-item label='用户名称'>
                <el-input v-model='tableStore.table.params.projectName' clearable></el-input>
            </el-form-item>
            <el-form-item label='所在地市'>
                <el-select v-model='tableStore.table.params.city' clearable placeholder='请选择所在地市'>
                    <el-option
                        v-for='item in areaOptionList'
                        :key='item.id'
                        :label='item.name'
                        :value='item.name'
                    ></el-option>
                </el-select>
            </el-form-item>
        </template>
        <template #operation>
            <el-button icon='' type='primary' @click='toGoNet()'>{{ titleButton }}</el-button>

            <el-button style='margin-left: 50px' :icon='Back'  @click='go(-1)'>返回</el-button>
        </template>
    </TableHeader> -->
        <div class="header_btn">
            <el-button v-if="bussType == 0 && !(jb_pl || jb_dky)" icon="" type="primary" @click="toGoNet()">
                {{ titleButton }}
            </el-button>
            <el-button
                v-if="bussType == 1 && needGovernance != '0' && !(jb_pl || jb_dky)"
                icon=""
                type="primary"
                @click="toGoNet()"
            >
                {{ titleButton }}
            </el-button>
            <el-button style="margin-left: 50px" :icon="Back" @click="go(-1)">返回</el-button>
        </div>
        <Table ref="tableRef" />

        <addForm
            v-if="dialogVisible"
            ref="addForms"
            :id="bussId"
            :bussType="bussType"
            :title="titleButton1"
            openType="detail"
            @onSubmit="tableStore.index()"
        ></addForm>
    </div>
</template>

<script setup lang="ts">
defineOptions({
    name: 'ProgramReview'
})

import { ref, onMounted, provide, nextTick, onUnmounted } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import { cancel, userReportGoNetById } from '@/api/supervision-boot/interfere/index'
import { useDictData } from '@/stores/dictData'
import addForm from './addForm.vue'
import { useRouter, useRoute } from 'vue-router'
import { Back } from '@element-plus/icons-vue'
import { useAdminInfo } from '@/stores/adminInfo'

const { go, currentRoute, push } = useRouter()
const { query } = useRoute() // 查询参数
import { ElMessage } from 'element-plus'
import { ElMessageBox } from 'element-plus/es'

const needGovernance = query.needGovernance as unknown as string // 从 URL 传递过来的 是否需要治理
const dictData = useDictData()
const areaOptionList = dictData.getBasicData('jibei_area')
const adminInfo = useAdminInfo()
const jb_pl = ref(false)
const jb_dky = ref(false)
jb_pl.value =
    adminInfo.$state.roleCode.filter(item => {
        return item == 'jb_pl'
    }).length != 0
        ? true
        : false
jb_dky.value =
    adminInfo.$state.roleCode.filter(item => {
        return item == 'jb_dky'
    }).length != 0
        ? true
        : false
const tableStore = new TableStore({
    url: '/supervision-boot/userReportNormal/userReportGoNetPage',

    method: 'POST',
    column: [
        {
            title: '序号',
            width: 80,
            formatter: (row: any) => {
                return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
            }
        },
        { field: 'projectName', title: '用户名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        { field: 'city', title: '所在地市', minWidth: 80 },
        { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        { field: 'substation', title: '厂站名称', minWidth: 100 },
        {
            field: 'status',
            title: '流程状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'warning',
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                0: '待提交审批',
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消'
            }
        },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        { field: 'createTime', title: '创建时间', minWidth: 100 },
        {
             title: '操作',fixed: 'right',
            minWidth: 180,
         
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    disabled: row => {
                        return !row.processInstanceId
                    },
                    click: row => {
                        handleAudit(row.processInstanceId, row.id)
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return !(row.status == 0 || row.status == 3)
                    },
                    disabled: row => {
                        return !(row.status == 0 || row.status == 3)
                    },
                    click: row => {
                        dialogVisible.value = true
                        titleButton1.value = '编辑'
                        setTimeout(() => {
                            addForms.value.open(row)
                        }, 0)
                    }
                },
                {
                    name: 'edit',
                    title: '重新发起',
                    type: 'warning',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 4)
                    },
                    click: row => {
                        dialogVisible.value = true
                        titleButton1.value = '重新发起'
                        setTimeout(() => {
                            addForms.value.open(row)
                        }, 0)
                    }
                },
                {
                    name: 'cancel',
                    title: '取消',
                    type: 'danger',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || row.status !== 1
                    },
                    click: row => {
                        cancelLeave(row)
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.userReportId = bussId.value
        tableStore.table.params.type = bussType.value
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.relationUserName = tableStore.table.params.userName
    }
})
tableStore.table.params.city = ''
tableStore.table.params.projectName = ''

const dialogVisible = ref(false)
const bussId = ref()
bussId.value = currentRoute.value.query.id

const bussType = ref()
bussType.value = Number(currentRoute.value.query.type)

const titleButton = ref()
const titleButton1 = ref()

provide('tableStore', tableStore)
const handleVisibilityChange = async () => {
    if (document.visibilityState === 'visible') {
        // 在这里执行页面回到回到当前页签需要做的事情
        await tableStore.index()
    } else if (document.visibilityState === 'hidden') {
        // 在这里执行页面离开时需要做的事情
    }
}
onMounted(async () => {
    tableStore.index()
    document.addEventListener('visibilitychange', handleVisibilityChange)
    if (query.fangAnId) {
        //根据id查询待编辑的数据
        await userReportGoNetById({ id: query.fangAnId }).then(res => {
            if (res && res.code == 'A0000') {
                dialogVisible.value = true
                titleButton1.value = '重新发起'
                setTimeout(() => {
                    res.data.id = query.fangAnId
                    addForms.value.open(res.data)
                }, 0)
            }
        })
    }
})
onUnmounted(() => {
    document.removeEventListener('visibilitychange', handleVisibilityChange)
})
/**取消流程操作*/
const cancelLeave = async (row: any) => {
    // 二次确认
    const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputType: 'textarea',
        inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
        inputErrorMessage: '取消原因不能为空'
    })
    // 发起取消
    let data = {
        id: row.id,
        processInstanceId: row.processInstanceId,
        reason: value
    }
    await cancel(data)
    ElMessage.success('取消成功')
    // 加载数据
    tableStore.index()
}
/** 处理审批按钮 */
const handleAudit = (instanceId: any, keyID: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        query: {
            id: instanceId,
            keyID: keyID
        }
    })
}
if (bussType.value === 0) {
    titleButton.value = '入网设计方案申请'
} else {
    titleButton.value = '治理工程申请'
}
const addForms = ref()
const toGoNet = () => {
    dialogVisible.value = true
    if (bussType.value === 0) {
        titleButton1.value = '入网设计方案申请'
    } else {
        titleButton1.value = '治理工程申请'
    }
    setTimeout(() => {
        addForms.value.open()
    }, 0)
}

/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}
</script>
<style scoped lang="scss">
.header_btn {
    width: 100%;
    height: 60px;
    display: flex;
    padding: 13px 15px;
    justify-content: flex-end;
    align-items: center;
    border: 1px solid #dddfe6;
}
</style>
